# NOTE
# - Warning: tests will fail if at same time tests are running (shared hw for
#   builders) as fixed port 20059 is used.
# - Warning: tests will fail inside vserver as binding to localhost, peername
#   is not 127.0.0.1 (will be ip of interfaces/0/ip instead)
#
# Conditional build:
%bcond_without	tests	# don't run tests

%define         webapp          hgweb
%define         webappdir       %{_sysconfdir}/webapps/%{webapp}
%define         appdir          %{_datadir}/%{webapp}
%define         cgibindir       %{_prefix}/lib/cgi-bin
Summary:	Mercurial Distributed SCM
Summary(pl.UTF-8):	Mercurial - rozproszony SCM
Name:		mercurial
Version:	2.8.1
Release:	1
License:	GPL v2
Group:		Development/Version Control
Source0:	http://mercurial.selenic.com/release/%{name}-%{version}.tar.gz
# Source0-md5:	bede5869f9b5d09ab3269bac472495e7
Source1:	gtools.py
Source2:	%{name}-%{webapp}.config
Source3:	%{name}-%{webapp}-httpd.config
Patch0:		%{name}-doc.patch
Patch1:		%{name}-clean-environment.patch
URL:		http://mercurial.selenic.com/
BuildRequires:	gettext-tools
BuildRequires:	python >= 1:2.4
BuildRequires:	python-devel
BuildRequires:	python-docutils
BuildRequires:	python-pygtk-gtk
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.219
%{?with_tests:BuildRequires:	unzip}
Requires:	python-modules
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Mercurial is a fast, lightweight source control management system
designed for efficient handling of very large distributed projects.
Features include:
- O(1) delta-compressed file storage and retrieval scheme
- Complete cross-indexing of file and changesets for efficient
  exploration of project history
- Robust SHA1-based integrity checking and append-only storage model
- Decentralized development model with arbitrary merging between trees
- High-speed HTTP-based network merge protocol
- Easy-to-use command-line interface
- Integrated stand-alone web interface
- Small Python codebase
- GPL license

%description -l pl.UTF-8
Mercurial to szybki, lekki system zarządzania kodem źródłowym
zaprojektowany do wydajnej obsługi bardzo dużych rozproszonych
projektów. Możliwości obejmują:
- przechowywanie skompresowanych plików różnic i schemat odtwarzania
  O(1)
- pełne indeksowanie plików i zmian w celu szybkiego przeglądania
  historii projektu
- silne, oparte na SHA1 sprawdzanie integralności oraz model
  przechowywania z samym dołączaniem
- zdecentralizowany model rozwoju z dowolnym łączeniem między drzewami
- szybki protokół łączenia po sieci oparty na HTTP
- łatwy w użyciu interfejs linii poleceń
- zintegrowany samodzielny interfejs WWW
- mały kod podstawowy w Pythonie
- licencja GPL

%package hgweb
Summary:	Scripts for serving mercurial repositories over HTTP
Summary(pl.UTF-8):	Skrypty do serwowania repozytoriów mercuriala przez HTTP
Group:		Development/Version Control
Requires:	%{name} = %{version}-%{release}
Requires:	apache-mod_wsgi >= 1.1
Requires:	webapps

%description hgweb
CGI scripts for serving mercurial repositories

%description hgweb -l pl.UTF-8
Skrypty CGI do serwowania repozytorió w mercuriala

%package hgk
Summary:	GUI for mercurial
Summary(pl.UTF-8):	Graficzny interfejs użytkownika dla systemu Mercurial
Group:		Development/Version Control
Requires:	%{name} = %{version}-%{release}
Requires:	python-modules

%description hgk
A tool called that allows browsing the history of a repository in a
GUI.

To enable it add to .hgrc file:
[extensions]
hgk=

%description hgk -l pl.UTF-8
Narzędzie pozwalające na przeglądanie historii repozytorium w
graficznym interfejsie użytkownika.

Aby je uaktywnić, należy dodać do pliku .hgrc:
[extensions]
hgk=

%prep
%setup -q
%patch0 -p1
%patch1 -p0
cp -p %{SOURCE1} hgext/gtools.py

%build
%{__python} setup.py build
%{__make} -C doc

%if %{with tests}
cd tests
%{__python} run-tests.py %{?_smp_mflags} --verbose
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install \
	--optimize=2 \
	--root=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{cgibindir},%{webappdir}}
install -p *.cgi $RPM_BUILD_ROOT%{cgibindir}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{webappdir}/%{webapp}.config
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{webappdir}/apache.conf
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{webappdir}/httpd.conf

install -p contrib/hgk $RPM_BUILD_ROOT%{_bindir}

install -d $RPM_BUILD_ROOT%{_mandir}/man{1,5}
cp -p doc/*.1 $RPM_BUILD_ROOT%{_mandir}/man1
cp -p doc/*.5 $RPM_BUILD_ROOT%{_mandir}/man5

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin hgweb -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{webapp}

%triggerun hgweb -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{webapp}

%triggerin hgweb -- apache < 2.2.0, apache-base
%webapp_register httpd %{webapp}

%triggerun hgweb -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{webapp}

%files
%defattr(644,root,root,755)
%doc CONTRIBUTORS README
%attr(755,root,root) %{_bindir}/hg
%{py_sitedir}/hgext
%dir %{py_sitedir}/%{name}
%attr(755,root,root) %{py_sitedir}/%{name}/*.so
%{py_sitedir}/%{name}/*.py[co]
%{py_sitedir}/%{name}/help
%{py_sitedir}/%{name}/hgweb
%{py_sitedir}/%{name}/httpclient
%{py_sitedir}/%{name}/templates
%dir %{py_sitedir}/%{name}/locale
%lang(da) %{py_sitedir}/%{name}/locale/da
%lang(de) %{py_sitedir}/%{name}/locale/de
%lang(el) %{py_sitedir}/%{name}/locale/el
%lang(fr) %{py_sitedir}/%{name}/locale/fr
%lang(it) %{py_sitedir}/%{name}/locale/it
%lang(ja) %{py_sitedir}/%{name}/locale/ja
%lang(pt_BR) %{py_sitedir}/%{name}/locale/pt_BR
%lang(ro) %{py_sitedir}/%{name}/locale/ro
%lang(ru) %{py_sitedir}/%{name}/locale/ru
%lang(sv) %{py_sitedir}/%{name}/locale/sv
%lang(zh_CN) %{py_sitedir}/%{name}/locale/zh_CN
%lang(zh_TW) %{py_sitedir}/%{name}/locale/zh_TW
%if "%{py_ver}" > "2.4"
%{py_sitedir}/*.egg-info
%endif
%{_mandir}/man1/*.1*
%{_mandir}/man5/*.5*

%files hgweb
%defattr(644,root,root,755)
%dir %{cgibindir}
%attr(755,root,root) %{cgibindir}/*.cgi
%dir %{webappdir}
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{webappdir}/apache.conf
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{webappdir}/hgweb.config
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{webappdir}/httpd.conf

%files hgk
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/hgk
%changelog
* Tue Jul 07 2015 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/mercurial.git;a=log;h=master

* Sun Dec 28 2014 Jan Rękorajski <baggins@pld-linux.org> 9b46881
- updated gettext BR

* Sat Dec 07 2013 Jan Rękorajski <baggins@pld-linux.org> 168dc3c
- up to 2.8.1

* Thu Sep 26 2013 Elan Ruusamäe <glen@delfi.ee> 246e7e3
- multi apache version config; NB main package does not depend/conflict on apache!

* Thu Sep 26 2013 Elan Ruusamäe <glen@delfi.ee> de44d27
- Revert "- migrated to apache 2.4"

* Sat Jun 08 2013 Kacper Kornet <draenog@pld-linux.org> 4504fb1
- updated to 2.6.2

* Sun Jun 02 2013 Kacper Kornet <draenog@pld-linux.org> e7776cb
- updated to 2.6.1

* Sun Jun 02 2013 Kacper Kornet <draenog@pld-linux.org> b086b2d
- run tests in parallel

* Sun Jun 02 2013 Kacper Kornet <draenog@pld-linux.org> ebd2c38
- unset GIT_DIR and GIT_WORK_TREE at the beginning of tests

* Wed May 15 2013 Jan Rękorajski <baggins@pld-linux.org> 79b6409
- migrated to apache 2.4

* Mon May 13 2013 wrobell <wrobell@pld-linux.org> 8fdb79f
- ver. 2.6

* Wed Jul 04 2012 Łukasz Kieś <kiesiu@pld-linux.org> bb8fcb5
- updated to 2.2.3

* Mon Jun 11 2012 Łukasz Kieś <kiesiu@pld-linux.org> 11a1a8e
- updated to 2.2.2

* Thu Apr 05 2012 Andrzej Zawadzki <zawadaa@gmail.com> 430f5e2
- up to 2.1.2

* Sun Mar 11 2012 Andrzej Zawadzki <zawadaa@gmail.com> 4be11fc
- add BR: python-pygtk-gtk - thanks arekm in this investigation
- STBR

* Sun Mar 11 2012 Andrzej Zawadzki <zawadaa@gmail.com> fd3c0b7
- up to 2.1.1

* Tue Jan 17 2012 Łukasz Kieś <kiesiu@pld-linux.org> 251377c
- updated to 2.0.2

* Sun Dec 04 2011 Łukasz Kieś <kiesiu@pld-linux.org> 879a655
- obsolete

* Sun Dec 04 2011 Łukasz Kieś <kiesiu@pld-linux.org> f5febaf
- updated to 2.0.1

* Thu Oct 13 2011 Andrzej Zawadzki <zawadaa@gmail.com> 1cb5c12
- for mercurial-hgweb

* Thu Oct 13 2011 Andrzej Zawadzki <zawadaa@gmail.com> 3113415
- up to 1.9.3
- long waiting patches ;-) - build mercurial-hgweb - for hg servers
- I don't know is this proper way but works 2 years

